#include "parti.h"

void 
PARTI_scatter(sched, data, target, size, func)
SCHED *sched;			/* schedule */
char  *data,*target;		/* data arrays */
int   size;			/* size of each elements in arrays */
void  (*func)();		/* function */
{
  int  count,i;
  char **blist,*buffer;
  char *ptr;
  int  *ibuf, *idata;
  double *dbuf, *ddata;
  double start, end;

#ifdef DEBUG
  trace_enter("new_scatter");
#endif

  blist = wbuffer->blist;
  buffer = (char *) malloc(size*sched->ndata);
  for(i=0, count = 0; i<PARTI_numnodes; i++){
    blist[i] = &buffer[count];
    count += size * sched->sr->fetch_n[i];
  } 

  /* set up the buffer */
  switch (size) {
  case sizeof(int):
    ibuf  = (int *) buffer;
    idata = (int *) data;
    if (sched->type == NC) {
      for (i=0; i<sched->ndata; i++)
	ibuf[i] = idata[sched->local_refs[sched->perm[i]]];
    }
    else {
      for (i=0; i<sched->ndata; i++)
        ibuf[i] = idata[sched->perm[i]];
    }
    break;
  case sizeof(double):
    dbuf  = (double *) buffer;
    ddata = (double *) data;
    if (sched->type == NC) {
      for (i=0; i<sched->ndata; i++)
	dbuf[i] = ddata[sched->local_refs[sched->perm[i]]];
    }
    else {
      for (i=0; i<sched->ndata; i++)
        dbuf[i] = ddata[sched->perm[i]];
    }
    break;
  case sizeof(char):
    if (sched->type == NC) {
      for (i=0; i<sched->ndata; i++)
	buffer[i] = data[sched->local_refs[sched->perm[i]]];
    }
    else {
      for (i=0; i<sched->ndata; i++)
        buffer[i] = data[sched->perm[i]];
    }
    break;
  default:
    if (sched->type == NC) {
      for(i=0,ptr=buffer;i<sched->ndata;i++,ptr+=size)
	bytecopy(ptr, &data[sched->local_refs[size*sched->perm[i]]], size);
    }
    else {
      for(i=0,ptr=buffer;i<sched->ndata;i++,ptr+=size)
        bytecopy(ptr, &data[size*sched->perm[i]], size); 
    }
    break;
  }  

  new_execute_scatter(sched->sr, blist, target, size, func);

  free(buffer);
#ifdef DEBUG
  trace_exit();
#endif
}

/*
 *  wrapper for the scatter function
 */

extern SCHED *get_sched_ptr();

void 
parti_scatter_ (sched, data, target, size, func)
int   *sched;			/* schedule */
char  *data,*target;		/* data arrays */
int   *size;			/* size of each elements in arrays */
int   *func;			/* function */

{
  PARTI_scatter((SCHED *)get_sched_ptr(*sched), data, target, *size, *func);
}
